<html lang="en">
<head>
<title>Writing Methods - Enhanced Implementation of Emacs Interpreted Objects</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Enhanced Implementation of Emacs Interpreted Objects">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="prev" href="Accessing-Slots.html#Accessing-Slots" title="Accessing Slots">
<link rel="next" href="Predicates.html#Predicates" title="Predicates">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Writing-Methods"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="Predicates.html#Predicates">Predicates</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="Accessing-Slots.html#Accessing-Slots">Accessing Slots</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="index.html#Top">Top</a>
<hr>
</div>

<!-- node-name,  next,  previous,  up -->
<h2 class="chapter">7 Writing Methods</h2>

<p>Writing a CLOS style method is similar to writing a function.  The
differences are that there are some extra options and there can be
multiple implementations of a single method which interact interestingly
with each other.

   <p>Each method created verifies that there is a <dfn>generic method</dfn>
available to attach to.  A generic method has no body, and is merely a
symbol upon which methods are attached.

<div class="defun">
&mdash; Function: <b>defgeneric</b><var> method arglist </var>[<var>doc-string</var>]<var><a name="index-defgeneric-23"></a></var><br>
<blockquote>
<p><var>method</var> is the unquoted symbol to turn into a function. 
<var>arglist</var> is the default list of arguments to use (not implemented yet). 
<var>doc-string</var> is the documentation used for this symbol.

        <p>A generic function acts as a place holder for methods.  There is no need
to call <code>defgeneric</code> yourself, as <code>defmethod</code> will call it if
necessary.  Currently the argument list is unused.

        <p><code>defgeneric</code> will prevent you from turning an existing emacs lisp
function into a generic function. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>defmethod</b><var> method </var>[<var>:BEFORE | :PRIMARY | :AFTER | :STATIC </var>]<var> arglist </var>[<var>doc-string</var>]<var> forms<a name="index-defmethod-24"></a></var><br>
<blockquote>
<p><var>method</var> is the name of the function to be created.

        <p><var>:BEFORE | :AFTER</var> represent when this form is to be called.  If
neither of these symbols are present, then the default priority is,
before <var>:AFTER</var>, after <var>:BEFORE</var>, and is represented in CLOS as
<var>PRIMARY</var>.

        <p>If <var>:STATIC</var> is used, then the first argument when calling this
function can be a class or an object.  Never treat the first argument
of a STATIC method as an object, always used <code>oref-default</code> or
<code>oset-default</code>.  A Class' construction is defined as a static
method.

        <p><code>arglist</code> is the argument list.  Unlike CLOS, only the FIRST
argument may be type-cast, and it may only be type-cast to an EIEIO
object.  An arglist such as <code>(a b)</code> would classify the function
as generic call, which has no object it can talk to (none is passed
in) and merely allows the creation of side-effects.  If the arglist
appears as <code>((this data-object) b)</code> then the form is stored as
belonging to the class <code>data-object</code>.

        <p>The first argument does not need to be typecast.  A method with no
typecast is a <code>generic</code>.  If a given class has no implementation,
then the generic will be called when that method is used on a given
object of that class.

        <p>If two <code>defmethod</code>s appear with arglists such as <code>(a b)</code>
and <code>(c d)</code> then one of the implementations will be overwritten,
but generic and multiple type cast arglists can co-exist.

        <p>When called, if there is a method cast against the object's parent
class, but not for that object's class, the parent class' method will be
called.  If there is a method defined for both, only the child's method
is called.

        <p><var>doc-string</var> is the documentation attached to the implementation. 
All method doc-strings are concatenated into the generic method's
function documentation.

        <p><var>forms</var> is the body of the function.

        <p>If multiple methods and generics are defined for the same method name,
they are executed in this order:

          <dl>
<dt>method :BEFORE<br><dt>generic :BEFORE<br><dt>method :PRIMARY<br><dt>generic :PRIMARY<br><dt>method :AFTER<br><dt>generic :AFTER<dd></dl>
        </p></blockquote></div>

   <p>If in any situation a method does not exist, but a generic does, then
the generic is called in place of the method.

   <p>If no methods exist, then the signal <code>no-method-definition</code> is
thrown. <a href="Signals.html#Signals">Signals</a>

   <p>See the file <samp><span class="file">eieio-test.el</span></samp> for an example testing these
differently tagged methods.

<div class="defun">
&mdash; Function: <b>call-next-method</b><var> &amp;rest replacement-args<a name="index-call_002dnext_002dmethod-25"></a></var><br>
<blockquote>
<p>While running inside a CLOS method, calling this function will call the
method associated with the parent of the class of the currently running
method with the same parameters.

        <p>If no next method is available, but a generic is implemented for the
given key (Such as <code>:BEFORE</code>), then the generic will be called.

        <p>OPTIONAL arguments <var>replacement-args</var> can be used to replace the
arguments the next method would be called with.  Useful if a child class
wishes to add additional behaviors through the modification of the
parameters.  This is not a feature of CLOS.

        <p>For example code See <a href="Default-Superclass.html#Default-Superclass">Default Superclass</a>.

        </blockquote></div>

<div class="defun">
&mdash; Function: <b>call-next-method-p</b><var><a name="index-call_002dnext_002dmethod_002dp-26"></a></var><br>
<blockquote>
<p>Return t if there is a next method we can call.

        </blockquote></div>

   <p>In this implementation, not all features of CLOS exist.

     <ol type=1 start=1>
<li>There is currently no :AROUND tag. 
<li>CLOS allows multiple sets of type-cast arguments, where eieio only
allows the first argument to be cast.
        </ol>

   </body></html>

